
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>记一次“动态方法名”调用 / 憋错料</title>

    <meta name="description" content="记一次“动态方法名”调用 接到需求,为APP提供数据调用接口,需要保证客户端请求路径不变(请求头中的方法版本信息可以根据需求进行调整). 最直观的想法是通过配置文件来完成. 例如在xml中,通过版本号,方法名,Service名来唯一定位需要执行的方法. 上述方法貌似可以解决问题.可是增加了很多无意义的重复劳动. 再想想,通过定义规范,注解,反射貌似也可以完成. 规范如下: 方法名+版本号,例如:findUser_1_0_1(String username); 在进行版本迭代的时候,对版本号进行调整.例如findUser_">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">记一次“动态方法名”调用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>接到需求，为APP提供数据调用接口，需要保证客户端请求路径不变（请求头中的方法版本信息可以根据需求进行调整）。</p>
<p>最直观的想法是通过配置文件来完成。</p>
<p>例如在xml中，通过版本号，方法名，Service名来唯一定位需要执行的方法。</p>
<p>上述方法貌似可以解决问题。可是增加了很多无意义的重复劳动。</p>
<p>再想想，通过定义规范，注解，反射貌似也可以完成。</p>
<p>规范如下：</p>
<p>　方法名+版本号，例如：findUser_1_0_1(String username);</p>
<p>在进行版本迭代的时候，对版本号进行调整。例如findUser_1_0_3(String username);</p>
<p>于此同时，在需要&ldquo;动态方法名&rdquo;的调用的方法上加入自定义注解（记录版本号）。</p>
<p>这个注解的作用，主要用来接收前段head中的版本信息，结合方法名。完成方法名的构造。</p>
<p>最后，通过反射，获取到被调用类上，有自定义注解的所有方法。</p>
<p>根据前段传递过来的方法名与版本号进行拼接。</p>
<p>将拼接结果与方法进行比对。</p>
<p>而后invoke回去即可完成"动态"方法调用。</p>
<p>为了代码的美观，将上述代码抽离成父类，供子类继承。</p>
<p>当然，这么搞也是需要做重复工作的，例如，每个Service都要继承BaseService（存放抽离代码的类）。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-13 18:07:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>记一次“动态方法名”调用的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dzN6r4.html" rel="bookmark">Action中动态方法的调用  Action中通配符的使用  Result的配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   Action中动态方法的调用 动态方法调用(Dynamic Method Invocation,DMI) 标识符:! 一.通过以下选中的文件来查看是否禁止调用动态方法 二.在我们自定义的action类中,我们不再单一的继承来自父类的方法,我们可以自定义自己的方法 1 package cn.jbit.booklist; 2 3 import com.opensymphony.xwork2.ActionSupport; 4 5 public class BookList extends Act			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eblkv3.html" rel="bookmark">iOS实现调用动态方法名有返回值的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				需求: 有10个类, 每个类里头都有n个方法(前提是方法名有规律可循,比如 setA0,setA1-)  如果挨个去init类, 然后挨个调用方法,这样你一天就不用干别的了 简单的解决方法可以参考这个: iPhone开发中,动态调用类和方法 虽然说performSelector有返回值,但是在ARC下会有警告,因为方法名是动态的,系统并不知道返回值是什么样的类型.解决方法可以见这篇文章: &quot;performSelector may cause a leak because its selector			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/x0dwa9M.html" rel="bookmark">struts2动态方法无法调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				struts2 大约2.3版本以后,调用动态方法会产生类似下面的错误 :Unable to instantiate Action, top.juson.study.action.Action2!eat, defined for 'action2!eat' in namespace '/'top.juson.study.action.Action2!eat 其中的defined for 'action2!eat' 说明这里没有把eat正常的解析为方法,而是和前面的action一起解析成了方法, 原			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QawnB4.html" rel="bookmark">Struts 2之动态方法调用，不会的赶紧来</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习Struts2框架以来为了减少Action 的数量,我们可以使用动态方法进行处理. 动态方法调用(Dynamic Method Invocation,DMI)是指表单元素的Action并不是直接等于某个Action的名称,而是通过 在Action的名称中使用感叹号(!)来标识要调用的方法名称,格式为actionName! methodName.action. 但是由于动态方法的调用可能会带来安全隐患(通过URL可以执行Action中的任意方法),所以在确定使用动态方法调用时, 应该确保Act			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6Bre5M.html" rel="bookmark">Struts2的动态方法&comma;及result跳转方式&comma;全局结果以及默认的action的配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Action动态方法的调用 首先我们需要在struts.xml中去配置一个常量值如下 那么去哪找呢?找到Struts-core.jar并打开 method属性 &lt;action name=&quot;login&quot; class=&quot;cn.ssh.ch08.UserAction&quot; method=&quot;lgoin&quot;&gt; &lt;result name=&quot;success&quot;&gt;/success.jsp&lt;/result&gt; &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wro5Y0.html" rel="bookmark">C&num;动态方法调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				此篇将介绍C#如何在运行时动态调用方法.当某些类型是运行时动态确定时,编译时的静态编码是无法解决这些动态对象或类的方法调用的.此篇则给你一把利剑,让动态对象的方法调用成为可能. 1.动态调用dll里的方法: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzQXqO4.html" rel="bookmark">Struts2系列：（7）通配符和动态方法调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当前存在的问题:在struts.xml配置文件中,每个action标签对应一个类中的方法.但是,在实际JavaWeb项目开发中,有许多继承自ActionSupport类的类(其中也包括很多方法),如果每个方法对应一个action标签,那么就会造成struts.xml非常庞大. 本节中介绍的通配符 和 动态方法调用 就是为了解决这一问题.本节分成2个部分:(1)通配符映射 和 (2)动态调用 概念:Struts应用可能有很多action 声明,可把多个相似的映射关系简化为一个(通用)映射关系的机制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QAmyw4.html" rel="bookmark">struts&period;enable&period;DynamicMethodInvocation &equals; true 动态方法调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				default.properties 在Struts 2的核心jar包-struts2-core中,有一个default.properties的默认配置文件.里面配置了一些全局的信息,比如: struts.enable.DynamicMethodInvocation = true,-动态方法调用,为true时,就可以在struts.xml配置“*”的通配符,来调用action里的方法(下面介绍) struts.action.extension=action,-action 的后缀名,可以改成.t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0leyaX3.html" rel="bookmark">Struts2动态方法调用怎么写配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Struts2动态方法调用怎么写配置?可以这样: 1.Struts2入门之 HelloWorld  编写不依赖任何三方包的Action类 按照MVC架构,Action执行完后要返回显示的结果视图,所以,Action中的请求处理方法要返回一个逻辑名称来表示它要显示的结果视图,即方法的 返回值类型为代表逻辑名称的字符串. 在 struts.xml配置文件中配置Action类 struts.xml文件中的配置信息使用package进行分类和管理,不同的包对应不同的url访问路径,即在访问路径上就能区分			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/74QJkMR.html" rel="bookmark" class="title">类，main&lpar;&rpar;方法</a>
					<div>
						一.类 1.Java 源文件名必须与类名相同.Java源文件后缀名必须是java; 2.类的内容就是类名后面的一对大括号{}括起来的内容: 二.方法 1.方法也有方法名,有方法内容(方法体即方法的主体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aZdn3.html" rel="bookmark" class="title">Lazy Writer&amp;amp&semi;CheckPoint</a>
					<div>
						Lazy Writer存在的目的是对缓冲区进行管理.当缓冲区达到某一临界值时,Lazy Writer会将缓冲区内的脏页存入磁盘文件中,而将未修改的页释放并回收资源. CheckPoint或Lazy W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXR7X3.html" rel="bookmark" class="title">Python学习记录-2016-11-30</a>
					<div>
						今日内容: 猜年龄游戏和游戏优化: 依照上次代码: age = 22 guess_num = int(input(&quot;input your guess number:&quot;)) if g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pelBwM.html" rel="bookmark" class="title">如何将上传文件的浏览按钮修改为自定义按钮</a>
					<div>
						最近,在修改一个国际化项目,碰到一个上传文件的地方,要将显示为的浏览按钮修改为自定义英文的英文按钮Brows,虽说那个按钮会根据系统语言自动切换,但就是在自己电脑上看着不爽,非要改成英文. 大致思想就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRyYR0.html" rel="bookmark" class="title">关于C&num;中if else的一些用法</a>
					<div>
						首先说下一下if 的代码格式: if (条件){ 循环体 else if(条件){ 循环体 } else{ } } 代码的运行顺序就不多赘述了.在当前的学习中,有些同学经常会报错. 比如下面的代码:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX78OQ4.html" rel="bookmark" class="title">&lbrack;Other&rsqb;来做一个微信打印机吧 -- 微信打印的设计思路参考</a>
					<div>
						原文地址:来做一个微信打印机吧 -- 微信打印的设计思路参考 最近微信打印机小火了一把,比如印美团,747微信打印机,都是利用微信公共平台实现照片的打印. 具体流程: 扫描二维码关注公共主页 发送图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoDD94.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;微个日光里&rdquo;对JAVA&sol;IO基本的总结，在此保存方便复习，原文http&colon;&sol;&sol;blog&period;csdn&period;net&sol;xiebaochun&sol;article&sol;details&sol;29559881</a>
					<div>
						流 JAVA /IO 基本小结 通过一行常见的代码讨论:new BufferedReader(new InputStreamReader(System.in)) java的IO是基于流(stream) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDo9je4.html" rel="bookmark" class="title">闰年的输出</a>
					<div>
						★判断输入的年份段中有哪些年份是闰年,并统计闰年个数 #include&lt;stdio.h&gt; int main() { int year; int count=0; printf(&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGaK93.html" rel="bookmark" class="title">蹬悦轿惶痹视恼寂翰视旨抖甭鞍惶O&lpar;&cap;&lowbar;&cap;&rpar;O~&period;&period;&period;&period;</a>
					<div>
						http://passport.baidu.com/?business&amp;un=ZHA&amp;un=%E8%A5%84%E5%9F%8E%E5%87%BA%E5%8F%B0%E8%BF%99% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eybB50.html" rel="bookmark" class="title">移动端去除点击背影的css样式</a>
					<div>
						-webkit-tap-highlight-color 这个属性只用于iOS (iPhone和iPad).当你点击一个链接或者通过Javascript定义的可点击元素的时候,它就会出现一个半透明的灰色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nYR8pM.html" rel="bookmark" class="title">妙龄女子欲删开房记录 网上找黑客被骗上万元</a>
					<div>
						妙龄女子欲删开房记录 网上找黑客被骗上万元 回想起自己的遭遇,小刘脸色涨红,甚至难以启齿. 小刘是名姑娘,很注重自己的隐私.听说开房记录找人是可以查到的,她担心未来的男友查她的记录,所以想把之前的“痕 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZnabM.html" rel="bookmark" class="title">一篇关于用户需求，己方产品（服务）与竞争对手的小清单</a>
					<div>
						关于总结上述三个图例的产品(服务).在此先说明一下:A代表用户需求.B代表己方产品(服务).C代表竞争对手的产品(服务). 如第一图所示:现在在市面上的产品基本上都可以归纳位这一方面, 如A是网上购物 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbvbG3.html" rel="bookmark" class="title">GUI编程第一弹&lowbar;窗口</a>
					<div>
						说实话,学编程也有半年了,自从学了算法之后觉得编程语言什么的都是殊途同归,c++也没怎么看过,但STL里面的东西大都接触过,毕竟是用到了就去现学,总体来说也算是了解吧,但从一开始就很不喜欢在那个黑框框 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5NKn3.html" rel="bookmark" class="title">Hyper-V上运行的Linux虚拟机验证是否安装了集成服务</a>
					<div>
						Hyper-V上运行的Linux虚拟机验证是否安装了集成服务 ps aux|grep &quot;hv&quot;root       311  0.0  0.0      0     0 ?     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQ5aLM.html" rel="bookmark" class="title">【LeetCode 72】Edit Distance</a>
					<div>
						Given two words word1 and word2, find the minimum number of steps required to convert word1 to word2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEWnv4.html" rel="bookmark" class="title">Windows远程访问OEM乱码解决</a>
					<div>
						问题描述 发现用Windows访问Linux安装的Oracle时oem按钮总是乱码,整理解决方法如下: OEM简介及按钮乱码问题  http://www.linuxidc.com/Linux/2013 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWzyg3.html" rel="bookmark" class="title">你真的会用Java中的三目运算符吗</a>
					<div>
						桨я 辞录  怯ミ 藕谦 汨鲟 髁啐 坠邸 办秧 Б磁 根逞 尿磴 镛崽 ь浣 ダ杲 渚 萆 坭 徊リ 奏甫 坯普 a谰 獾 唑 的嗬 宴 浊徵 抵震 抬霜  ゐ掭 罂池 △ 镅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNWzE4.html" rel="bookmark" class="title">Kanzi编程基础 - 定时器</a>
					<div>
						Kanzi虽然发生了比较多的版本更迭,api也发生了很多变化,但定时器的头文件一直都在一个地方:#include &quot;user/include/user/ui/message/kzu_mess ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kwZD0.html" rel="bookmark" class="title">VS2013中设置全局属性</a>
					<div>
						为了更好的体现程序与库的独立性,vc++2013 中库路径设置不再采用全局设置,就是说在每个工程中都可以有自己独立的库路径设置,当然你如果不设置,那默认就是vs2013自己的库路径.但是如果你需要用到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpOn84.html" rel="bookmark" class="title">关于Interface忽然想到的</a>
					<div>
						其实Interface,顾名思义,就是2个事物的&quot;界面&quot;,interface衔接了2个事物,这两个事物,往往一方比较&quot;多变&quot;,而另一方我们又不太希望它相对&qu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
